// Copyright 2022 schukai GmbH
// SPDX-License-Identifier: AGPL-3.0

package configuration

import "github.com/imdario/mergo"

func (s *Settings[C]) Merge(change C) *Settings[C] {

	if s == nil {
		panic("struct is not initialized")
	}

	s.Lock()
	defer s.Unlock()

	if err := mergo.Merge(&s.config, change); err != nil {
		s.errors = append(s.errors, err)
	}

	return s
}
